IsolationLevelDataSourceRouter (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jdbc.datasource.lookup

## Class IsolationLevelDataSourceRouter

- java.lang.Object
- - org.springframework.jdbc.datasource.AbstractDataSource
  - - org.springframework.jdbc.datasource.lookup.AbstractRoutingDataSource
    - - org.springframework.jdbc.datasource.lookup.IsolationLevelDataSourceRouter

- All Implemented Interfaces:
    Wrapper, CommonDataSource, DataSource, InitializingBean

      public class IsolationLevelDataSourceRouter
      extends AbstractRoutingDataSource

  DataSource that routes to one of various target DataSources based on the current transaction isolation level. The target DataSources need to be configured with the isolation level name as key, as defined on the `TransactionDefinition interface`.

  This is particularly useful in combination with JTA transaction management (typically through Spring's `JtaTransactionManager`). Standard JTA does not support transaction-specific isolation levels. Some JTA providers support isolation levels as a vendor-specific extension (e.g. WebLogic), which is the preferred way of addressing this. As alternative (e.g. on WebSphere), the target database can be represented through multiple JNDI DataSources, each configured with a different isolation level (for the entire DataSource). The present DataSource router allows to transparently switch to the appropriate DataSource based on the current transaction's isolation level.

  The configuration can for example look like this, assuming that the target DataSources are defined as individual Spring beans with names "myRepeatableReadDataSource", "mySerializableDataSource" and "myDefaultDataSource":

       <bean id="dataSourceRouter" class="org.springframework.jdbc.datasource.lookup.IsolationLevelDataSourceRouter">
         <property name="targetDataSources">
           <map>
             <entry key="ISOLATION_REPEATABLE_READ" value-ref="myRepeatableReadDataSource"/>
             <entry key="ISOLATION_SERIALIZABLE" value-ref="mySerializableDataSource"/>
           </map>
         </property>
         <property name="defaultTargetDataSource" ref="myDefaultDataSource"/>
       </bean>

  Alternatively, the keyed values can also be data source names, to be resolved through a `DataSourceLookup`: by default, JNDI names for a standard JNDI lookup. This allows for a single concise definition without the need for separate DataSource bean definitions.

       <bean id="dataSourceRouter" class="org.springframework.jdbc.datasource.lookup.IsolationLevelDataSourceRouter">
         <property name="targetDataSources">
           <map>
             <entry key="ISOLATION_REPEATABLE_READ" value="java:comp/env/jdbc/myrrds"/>
             <entry key="ISOLATION_SERIALIZABLE" value="java:comp/env/jdbc/myserds"/>
           </map>
         </property>
         <property name="defaultTargetDataSource" value="java:comp/env/jdbc/mydefds"/>
       </bean>

  Note: If you are using this router in combination with Spring's `JtaTransactionManager`, don't forget to switch the "allowCustomIsolationLevels" flag to "true". (By default, JtaTransactionManager will only accept a default isolation level because of the lack of isolation level support in standard JTA itself.)

       <bean id="transactionManager" class="org.springframework.transaction.jta.JtaTransactionManager">
         <property name="allowCustomIsolationLevels" value="true"/>
       </bean>

  Since:
    2.0.1
  Author:
    Juergen Hoeller
  See Also:
    `AbstractRoutingDataSource.setTargetDataSources(java.util.Map<java.lang.Object, java.lang.Object>)`, `AbstractRoutingDataSource.setDefaultTargetDataSource(java.lang.Object)`, `TransactionDefinition.ISOLATION_READ_UNCOMMITTED`, `TransactionDefinition.ISOLATION_READ_COMMITTED`, `TransactionDefinition.ISOLATION_REPEATABLE_READ`, `TransactionDefinition.ISOLATION_SERIALIZABLE`, `JtaTransactionManager`

- - ### Field Summary

    - ### Fields inherited from class org.springframework.jdbc.datasource.AbstractDataSource

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IsolationLevelDataSourceRouter()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Object` | `determineCurrentLookupKey()` Determine the current lookup key.
    `protected Object` | `resolveSpecifiedLookupKey(Object lookupKey)` Supports Integer values for the isolation level constants as well as isolation level names as defined on the `TransactionDefinition interface`.

    - ### Methods inherited from class org.springframework.jdbc.datasource.lookup.AbstractRoutingDataSource

      `afterPropertiesSet, determineTargetDataSource, getConnection, getConnection, isWrapperFor, resolveSpecifiedDataSource, setDataSourceLookup, setDefaultTargetDataSource, setLenientFallback, setTargetDataSources, unwrap`

    - ### Methods inherited from class org.springframework.jdbc.datasource.AbstractDataSource

      `getLoginTimeout, getLogWriter, getParentLogger, setLoginTimeout, setLogWriter`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IsolationLevelDataSourceRouter

          public IsolationLevelDataSourceRouter()

  - ### Method Detail

    - #### resolveSpecifiedLookupKey

          protected Object resolveSpecifiedLookupKey(Object lookupKey)

      Supports Integer values for the isolation level constants as well as isolation level names as defined on the `TransactionDefinition interface`.
      Overrides:
        `resolveSpecifiedLookupKey` in class `AbstractRoutingDataSource`
      Parameters:
        `lookupKey` - the lookup key object as specified by the user
      Returns:
        the lookup key as needed for matching

    - #### determineCurrentLookupKey

          protected Object determineCurrentLookupKey()

      Description copied from class: `AbstractRoutingDataSource`
      Determine the current lookup key. This will typically be implemented to check a thread-bound transaction context.

      Allows for arbitrary keys. The returned key needs to match the stored lookup key type, as resolved by the `AbstractRoutingDataSource.resolveSpecifiedLookupKey(java.lang.Object)` method.

      Specified by:
        `determineCurrentLookupKey` in class `AbstractRoutingDataSource`